FORMAT: 1A
HOST: https://proxy.golemio.cz

# Golemio permission proxy

v1.1

## Versions

<!-- __DATE__ -->




# Group Authentication

Authenticating user and verifing access token.

## Login [POST /gateway/login]

User signing in and returning new access token.

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)

+ Response 401 (application/json; charset=utf-8)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: user@user.com
        + password: user

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + token: fokslkdfjsdlkfjl (string)

+ Request (application/json; charset=utf-8)
    + Attributes (Credentials)
        + email: admin@admin.com
        + password: admin

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + token: fokslkdfjsdlkfjl (string)


## Verify token [GET /gateway/verify]

Verifing the access token (token returned by login).

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401




# Group Users

Users management.

## Users [/gateway/user]

### Get All Users [GET]

TODO: Not implemented yet.

TODO: Complete the user data structure.

Getting all existing users.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (array)
        + (object)
            + id: 1 (required, number)
            + email: karelploc@gmail.com (required, string)
            + name: Karel (optional, string)
            + surname: Ploc (optional, string)

+ Response 401

+ Response 403

### Create New User [POST]

Creating or registering the new user. This method creates new user and sends email to verify email address (invitation).

TODO: If the logged user has admin access, he can create new user only with filled email address and referer url. This process creates new user without password and the invitation record contains attribute `need_password` set on `true`.

+ Request (application/json; charset=utf-8)

    + Headers

            Referer: https://domain2/client-panel
            x-access-token: fokslkdfjsdlkfjl

    + Attributes
        + email: karelploc@gmail.com (required, string)
        + password: xxx (optional, string)
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)

+ Response 201 (application/json; charset=utf-8)

+ Response 400

+ Response 401

+ Response 403

+ Response 409

## Detail of the User [/gateway/user/{id}]

+ Parameters
    + id: 1 (required, number)

### Get User [GET]

TODO: Not implemented yet.

TODO: Complete the user data structure.

Getting informations about user.

TODO: If the logged user has admin access, he can get any users, but logged user with basic access can get only itself.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + id: 1 (required, number)
        + email: karelploc@gmail.com (required, string)
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)

+ Response 401

+ Response 403

+ Response 404

### Edit User [PUT]

TODO: Not implemented yet.

TODO: Complete the user data structure.

Editing the user's informations.

TODO: If the logged user has admin access, he can edit any users, but logged user with basic access can edit only itself.

TODO: The admin users can set admin access to other users?

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes
        + email: karelploc@gmail.com (required, string)
        + password: xxx (optional, string)
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)

+ Response 200 (application/json; charset=utf-8)
    + Attributes (object)
        + id: 1 (required, number)
        + email: karelploc@gmail.com (required, string)
        + name: Karel (optional, string)
        + surname: Ploc (optional, string)

+ Response 400

+ Response 401

+ Response 403

+ Response 404

### Remove User [DELETE]

TODO: Not implemented yet.

Removing the user.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401

+ Response 403

+ Response 404




# Group Api Keys

Apikeys management.

## Api Keys [/gateway/api-key]

### Get Api Keys of the User [GET]

Returning all api keys of logged user (recognized by x-access-token).

TODO: If the logged user has admin access, all existing Api Keys containing users ids are returned.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Api key])

+ Response 401

### Create new Api Key for the User [POST]

Creating new Api Key for the logged user (recognized by x-access-token).

TODO: If the logged user has admin access, he can create new Api Key for the defined user (by user id).

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Api key)

+ Response 401

## Api Key Detail [/gateway/api-key/{id}]

+ Parameters
    + id: 1 (required, number)

### Get existing Api Key of the User [GET]

TODO: Not implemented yet.

Get information about Api Key of the logged user (recognized by x-access-token).

TODO: If the logged user has admin access, he can get any existing Api Key.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (Api key)

+ Response 401

+ Response 403

+ Response 404

### Remove existing Api Key of the User [DELETE]

Removing existing Api Key of the logged user (recognized by x-access-token).

TODO: If the logged user has admin access, he can remove any existing Api Key.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 400

+ Response 401

+ Response 404




# Group Forgotten Password

Forgotten password reset process.

## Forgotten Password Request [/gateway/forgotten-password]

### Create New Password Reset Request [POST]

Creating forgotten password request and sending it by an email.

+ Request (application/json; charset=utf-8)

    + Headers

            Referer: https://domain2/client-panel

    + Attributes
        + email: karelploc@gmail.com (fixed-type, string, required)

+ Response 201 (application/json; charset=utf-8)

+ Response 403

+ Response 404

## Forgotten Password Request Confirmation [/gateway/forgotten-password/{code}]

+ Parameters
    + code: `59fcf981-80a3-449d-8751-c06e161bc400` (required, string) - uuid4 format code

### Confirm and Set New Password [PUT]

+ Request (application/json; charset=utf-8)
    + Attributes
        + password: xxxx (fixed-type, string, required)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`
    + Attributes
        + password: test (fixed-type, string, required)

+ Response 204

+ Response 400




# Group Invitations

New user email verification process. Verification is represented by invitation.

## Detail of the Invitation [/gateway/invitation/{code}]

+ Parameters
    + code: `59fcf981-80a3-449d-8751-c06e161bc400` (required, string) - uuid4 format code

### Get Information about Invitation [GET]

Getting all information about invitation by code.

+ Request (application/json; charset=utf-8)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Invitation detail)

### Confirm the Invitation and Optionally Set New Password [PUT]

Confirming the user verification. Optionally cen be sent new user's password.

TODO: Is the PUT method correct for this case? Is the sending empty data by PUT correct?

TODO: Test password setting.

TODO: Now returning attribute `need_password`, what it is for?

+ Request (application/json; charset=utf-8)
    + Attributes
        + password: xxxx (fixed-type, string, optional)

+ Response 404

+ Request (application/json; charset=utf-8)
    + Parameters
        + code: `1`
    + Attributes
        + password: xxxx (fixed-type, string, optional)

+ Response 204

+ Response 400




# Group Rate Limits

User's rate limiting management.

## User's Rate Limit [/gateway/user/{userId}/rate-limit]

+ Parameters
    + userId: 1 (required, number)

### Get Rate Limit Information [GET]

TODO: Not implemented yet.

Getting information about user's rate limit.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (object)
        + limit: 100 (fixed-type, number, required) - number of request per 24 hours

+ Response 403

+ response 404

### Create New Rate Limit [POST]

TODO: Not implemented yet.

Creating the new rate limit for the user.

Only admin access

TODO: Add time period. (windowMs)

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + limit: 100 (fixed-type, number, required) - number of request per 24 hours

+ Response 201
    + Attributes (object)
        + limit: 100 (fixed-type, number, required) - number of request per 24 hours

+ Response 400

+ Response 403

+ response 404

### Edit Rate Limit [PUT]

Editing the rate limit.

Only admin access

TODO: Add time period. (windowMs)

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + limit: 100 (fixed-type, number, required) - number of request per 24 hours

+ Response 204

+ Response 400

+ Response 403

+ response 404




# Group Roles

User roles management.

## User Roles [/gateway/role]

### Get All Existing Roles [GET]

Getting existing user roles.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Role])

+ Response 401

+ Response 403

### Create New User Role [POST]

Creating the new user role.

Only admin access

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (required, string)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Role)

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (required, string)
        + parent_id: 0 (nullable, optional, number)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 404

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Semafory (required, string)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Role)

+ Response 401

+ Response 403

## Detail of User Role [/gateway/role/{id}]

+ Parameters
    + id: 1 (required, number)

### Get User Role [GET]

Getting user role info by ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Role)
        + scopes (array[Scope])

+ Response 401

+ Response 403

+ Response 404

### Edit User Role [PATCH]

Editing user role info.

Only admin access

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (optional, string)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + label: Parkoviste (optional, string)
        + parent_id: 0 (nullable, optional, number)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 404

+ Response 401

+ Response 403

### Remove User Role [DELETE]

Removing user role by ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 404

+ Response 401

+ Response 403




# Group Routes

Routing management. The routes defines proxy routing between endpoint url and target url.

## Routes [/gateway/route{?page,limit}]

+ Parameters
    + page: 1 (number, optional)
    + limit: 20 (number, optional)

### Get All Routes [GET]

Getting all existing routes.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Route])

+ Response 401

+ Response 403

### Create New Route [POST]

Creating new route. Cobinations of the pairs `endpoint` and `method` must be unique.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + endpoint: `/parkings` (required, string)
        + target_url: `http://output.gateway.golemio.cz` (required, string)
        + target_path: `/parkoviska` (optional, string)
        + public: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Request (application/json; charset=utf-8)
    + Attributes (object)
        + endpoint: `/semafory` (required, string)
        + target_url: `http://output.gateway.golemio.cz` (required, string)
        + target_path: `/semafory` (optional, string)
        + public: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Response 400

+ Response 401

+ Response 403

+ Response 409

## Publish [/gateway/route/publish]

Proxy cache refreshing.

TODO: Calling the method is not RESTful. Refresh/invalidation cache can be processed after every change in routes data.

### Publish Routes Changes [POST]

Publishing the made changes in routes data.

Only admin access.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401

+ Response 403

## Detail of Route [/gateway/route/{id}]

+ Parameters
    + id: 1 (number, required)

### Get Route [GET]

TODO: Not implemented yet.

Getting the route informations by ID.

Only admin access.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Route)

+ Response 401

+ Response 403

+ Response 404

### Edit Route [PATCH]

TODO: Not implemented yet.

Editing the route.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + endpoint: `/parkings` (required, string)
        + target_url: `http://golemio.cz/output.gateway` (required, string)
        + target_path: `/parkoviska` (optional, string)
        + public: false (optional, boolean)
        + method: `GET` (required, enum[string])
            + Members
                + POST

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Route)

+ Response 400

+ Response 401

+ Response 403

+ Response 404

### Remove Route [DELETE]

Removing the route by ID.

Only admin access.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404




# Group Scopes

Link between route and user role. Scope defines limitiations for user role to access the route.

TODO: should be access only by admin?

## Scopes [/gateway/role/{roleId}/scope]

+ Parameters
    + roleId: 1 (required, number)

### Get All Scopes [GET]

Getting all existing scopes by user role ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Scope])

+ Response 401

+ Response 403

### Create New Scope [POST]

Creating the new scope for user role. Cobinations of the pairs `role` and `route` must be unique.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + route_id: 1 (number, required)
        + limitations (array)
            + (object)
                + name: districts (required, string)
                + type: `in-array` (required, enum[string])
                    + Members
                        + `min-max`
                        + `ip`
                + block: true (required, boolean)
                + values (array[string], required)
                    + `praha-1`
                    + `praha-2`
            + (object)
                + name: limit (required, string)
                + type: `min-max` (required, enum[string])
                    + Members
                        + `in-array`
                        + `ip`
                + block: false (required, boolean)
                + min: 100 (optional, number)
                + max: 500 (optional, number)
            + (object)
                + name: ip (required, string)
                + type: `ip` (required, enum[string])
                    + Members
                        + `in-array`
                        + `min-max`
                + values (array[string], required)
                    + `192.168.1.*`

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 400

+ Response 401

+ Response 403

+ Response 409

## Detail of the Scope [/gateway/role/{roleId}/scope/{id}]

+ Parameters
    + roleId: 1 (required, number)
    + id: 1 (required, number)

### Get Scope Detail [GET]

Getting the scope by ID and user role ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 401

+ Response 403

+ Response 404

### Edit Scope [PATCH]

TODO: Not implemented yet.

Editing the scope.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + route_id: 1 (number, required)
        + limitations (array)
            + (object)
                + name: districts (required, string)
                + type: `in-array` (required, enum[string])
                    + Members
                        + `min-max`
                        + `ip`
                + block: true (required, boolean)
                + values (array[string], required)
                    + `praha-1`
                    + `praha-2`

+ Response 200 (application/json; charset=utf-8)
    + Attributes (Scope)

+ Response 401

+ Response 403

+ Response 404

### Remove Scope [DELETE]

Removing the scope by ID and user role ID.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401

+ Response 403

+ Response 404

## Limitations [/gateway/limitations]

### Get All Limitations [GET]

TODO: Not implemented yet.

Getting all options of limitations which can be set to the scope.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[string])

    + Body

            [
                "in-array", "min-max", "ip"
            ]

+ Response 401

+ Response 403




# Group User's Roles

User's roles management.

## User's Roles [/gateway/user/{userId}/role]

+ Parameters
    + userId: 1 (required, number)

### Get Roles of User [GET]

Getting all user's roles.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200 (application/json; charset=utf-8)
    + Attributes (array[Role])

+ Response 401

+ Response 403

+ Response 404

### Assign New Role to User [POST]

TODO: Not implemented yet.

Assigning the existing user role to the user.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

    + Attributes (object)
        + role_id: 1 (required, number)

+ Response 201 (application/json; charset=utf-8)
    + Attributes (Role)

+ Response 401

+ Response 403

+ Response 404

## Detail of User's Role [/gateway/user/{userId}/role/{roleId}]

+ Parameters
    + roleId: 1 (required, number)
    + userId: 1 (required, number)

### Assign [PUT]

TODO: DEPRECATED. Incorrect implementation of the creating new resource. New implementation by POST above.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 403

+ Response 404

### Revoke Role from User [DELETE]

Revoking the user role from the user.

Only admin access

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 204

+ Response 401

+ Response 403

+ Response 404




# Group User's Routes

## User's Routes [/gateway/user/{userId}/route]

+ Parameters
    + userId: 1 (number, required)

### Get Routes of User [GET]

Getting all routes of the user. User's routes are defined by the Scope (role-route pair). This endpoint helps to determine which routes are enabled for the user.

TODO: If the logged user has admin access, he can get routes of any user.

+ Request (application/json; charset=utf-8)

    + Headers

            x-access-token: fokslkdfjsdlkfjl

+ Response 200
    + Attributes (object)
        + endpoint: /parking (fixed-type, string)
        + method: GET (enum[string])
            + Members
                + POST
        + user_id: 1 (fixed-type, number)

+ Response 401

+ Response 403

+ Response 404





# Data Structures

## Credentials (object)
+ email: user@user.cz (fixed-type, string, required) - User login
+ password: xxxxxxx (fixed-type, string, required) - User password

## Api key (object)
+ id: 1 (fixed-type, number)
+ code: f49f03jfljfwjfjsfljf (fixed-type, string) - JWT type access token
+ user_id: 1 (fixed-type, number) - Owner id
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)

## Invitation detail (object)
+ need_password: false (fixed-type, boolean) - information if the user set his password
+ already_expired: false (fixed-type, boolean) - information if the invitation has already expired
+ already_accepted: false (fixed-type, boolean) - information if the user has already accepted the invitation into the system

## Role (object)
+ id: 1 (fixed-type, number)
+ label: Parkoviste (fixed-type, string) - Label of the role
+ parent_id: 1 (fixed-type, number, nullable) - Parent role id
+ `default`: false (fixed-type, boolean)
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)
+ created_by_user_id: 1 (fixed-type, number)
+ updated_by_user_id: 1 (fixed-type, number, nullable)

## Route (object)
+ id: 1 (fixed-type, number)
+ endpoint: /parking (fixed-type, string)
+ target_url: `http://mojepraha.eu` (fixed-type, string)
+ target_path: `/parkoviska` (fixed-type, string)
+ public: false (fixed-type, boolean)
+ method: GET (enum[string])
    + Members
        + POST
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)
+ created_by_user_id: 1 (fixed-type, number)
+ updated_by_user_id: 1 (fixed-type, number, nullable)

## Scope (object)
+ id: 1 (fixed-type, number)
+ role_id: 1 (fixed-type, number)
+ route_id: 1 (fixed-type, number)
+ limitations (array)
    + (object)
        + name: districts (string)
        + type: `in-array` (string)
        + block: true (boolean)
        + values (array[string])
            + `praha-1`
            + `praha-2`
+ created_at: `2019-01-01 12:00:00` (fixed-type, string)
+ updated_at: `2019-01-01 12:00:00` (fixed-type, string)
+ deleted_at: `2019-01-01 12:00:00` (fixed-type, string, nullable)
+ created_by_user_id: 1 (fixed-type, number)
+ updated_by_user_id: 1 (fixed-type, number, nullable)
